using static ProjectWarmlyShip.Direction;

namespace ProjectWarmlyShip
{
    /// <summary>
    ///     ""
    /// </summary>
    public partial class FormWarmlyShip : Form
    {
        /// <summary>
        /// -   
        /// </summary>
        private DrawingWarmlyShip? _drawingWarmlyShip;
        /// <summary>
        ///  
        /// </summary>
        public FormWarmlyShip()
        {
            InitializeComponent();
        }
        /// <summary>
        ///   
        /// </summary>
        private void Draw()
        {
            if (_drawingWarmlyShip == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxWarmlyShip.Width, pictureBoxWarmlyShip.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawingWarmlyShip.DrawTransport(gr);
            pictureBoxWarmlyShip.Image = bmp;
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingWarmlyShip = new DrawingWarmlyShip();
            _drawingWarmlyShip.Init(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)),
            pictureBoxWarmlyShip.Width, pictureBoxWarmlyShip.Height);
            _drawingWarmlyShip.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonMove_Click(object sender, EventArgs e)
        {
            if (_drawingWarmlyShip == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawingWarmlyShip.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    _drawingWarmlyShip.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    _drawingWarmlyShip.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    _drawingWarmlyShip.MoveTransport(DirectionType.Right);
                    break;
            }
            Draw();
        }
    }
}